package  whiteship.crud.domain {

	import org.as3commons.lang.ICloneable;
	import org.springextensions.actionscript.domain.ICopyFrom;

	[Bindable]
	public class Todo implements ICloneable, ICopyFrom {

		public var id:int;
		public var todo:String;
		public var startdate:Date;
		public var enddate:Date;

		// --------------------------------------------------------------------
		//
		// Constructor
		//
		// --------------------------------------------------------------------

		public function Todo(id:int = -1, todo:String = "", startdate:Date = null, enddata:Date = null) {
			this.id = id;
			this.startdate = ( startdate == null ) ?  new Date() : startdate;
			this.enddate = ( enddate == null ) ?  new Date() : enddate;
		}

		// --------------------------------------------------------------------
		//
		// Implementation: ICloneable
		//
		// --------------------------------------------------------------------

		public function clone():* {
			var result:Todo = new Todo();
			result.copyFrom(this);
			return result;
		}

		// --------------------------------------------------------------------
		//
		// Implementation: ICopyFrom
		//
		// --------------------------------------------------------------------

		public function copyFrom(other:*):void {
			if (other is Todo) {
				var that:Todo = Todo(other);
				id = that.id;
				todo = that.todo;
				startdate = new Date(that.startdate.time);
				enddate = new Date(that.enddate.time);
			}
		}

	}
}